import Driver from "driver.js";
import "driver.js/dist/driver.min.css";

class TourHelper {
  constructor() {
    this.keys = [];
    this.storage = window.localStorage;

    this.driver = new Driver({
      doneBtnText: "Done",
      closeBtnText: "Skip tour",
      nextBtnText: "Next tip",
      prevBtnText: "Prev",
      onHighlighted: element => {
        console.log("onHighlighted", element);
        // TODO
        // this.keys.forEach(value => this.storage.removeItem(value));
        // this.storage.setItem(element.node.dataset.key, 1);
      }
    });

    this.elements = [];
  }
}

const helper = new TourHelper();

export default {
  methods: {
    registerTour() {
      if (this.spec.tour) {
        helper.elements.push(this);
      }
    },
    startTour() {
      if (helper.elements && helper.elements.length > 0) {
        helper.elements = Array.from(helper.elements).sort(
          (a, b) => a.index - b.index
        );
        let stepDefinitions = helper.elements.map(element => {
          const tourSpec = element.spec.tour;

          return {
            element: element.$el,
            popover: {
              title: tourSpec.title,
              description: tourSpec.message,
              position: tourSpec.position
            }
          };
        });

        // TODO
        // this.keys = helper.elements.map(value => value.dataset.key);

        helper.driver.defineSteps(stepDefinitions);

        helper.driver.start(this.latestTourStep());
      }
    },
    latestTourStep() {
      let step = 0;

      // TODO
      // Array.from(this.elements).forEach(element => {
      //   if (this.storage.getItem(element.dataset.key)) {
      //     step = parseInt(element.dataset.index);
      //   }
      // });
      // return step;

      return step;
    }
  }
};
