export default class {
  static isObject(obj) {
    return typeof obj === "object" && obj !== null;
  }
  static isString(obj) {
    return typeof obj === "string";
  }
  static isNumber(obj) {
    return typeof obj === "number" && !isNaN(obj);
  }
  static isBoolean(obj) {
    return typeof obj === "boolean";
  }
  static isArray(obj) {
    return this.isObject(obj) && Array.isArray(obj);
  }
  static isFunction(obj) {
    return typeof obj === "function";
  }
  static isNotNull(obj) {
    return typeof obj !== "undefined" && obj !== null;
  }

  static ifObject(obj, ifCommand, elseCommand) {
    if (this.isObject(obj)) {
      ifCommand(obj);
    } else if (elseCommand) {
      elseCommand();
    }
  }
  static ifString(obj, command) {
    if (this.isString(obj)) {
      command(obj);
    }
  }
  static ifNumber(obj, command) {
    if (this.isNumber(obj)) {
      command(obj);
    }
  }
  static ifBoolean(obj, command) {
    if (this.isBoolean(obj)) {
      command(obj);
    }
  }
  static ifArray(obj, command) {
    if (this.isArray(obj)) {
      command(obj);
    }
  }
  static ifFunction(obj, command) {
    if (this.isFunction(obj)) {
      command(obj);
    }
  }
  static ifNotNull(obj, command) {
    if (this.isNotNull(obj)) {
      command(obj);
    }
  }

  static floatValue(obj) {
    return this.float(obj) || 0;
  }
  static float(obj) {
    const val = parseFloat(obj);
    return isNaN(val) ? null : val;
  }
}
